Subject: RE: emacs -nw keypad
From: "Tim Adye" <[email-masked]>
To: <[email-masked]>
Cc: "'Ken Brown'" <[email-masked]>, "'Eli Zaretskii'" <[email-masked]>
Date: Wed, 27 May 2009 02:11:44 +0100
List-Id: <cygwin.cygwin.com>

Hi Eli and Ken,

Thank you for all your investigations.

Ken Brown wrote on 26 May 2009 21:59:
> 
> On 5/26/2009 4:03 PM, Eli Zaretskii wrote:
> > It would really help me to see the result of typing "C-h l" after 
> > pressing the keypad keys, on Tim's machine, as I requested 
> > earlier in this thread.
>
> I can't help you with Tim's machine, but I tried it on my 
> own.  (I'm currently running emacs-23.0.94 in cygwin-1.7.)  
> It's clear that the keypad keys are not recognized as such 
> when running emacs in rxvt or emacs -nw in an xterm.  The 
> same thing happens in a third terminal that I tried, mintty.
>
> In addition, emacs sees C-h as DEL in all three cases, so it 
> isn't recognized as the help key.  I had to use F1 for help.

Aha! That's how to do it.

> Here are the results.  First, for comparison, I ran emacs 
> under X (without -nw).  With numlock on, I typed '123456' on 
> the keypad, followed by C-h l.  The results were as expected:
> 
> 	<kp-1> <kp-2> <kp-3> <kp-4> <kp-5> <kp-6> C-h l

Yes, I see the same with this one.

> Next, I tried the three terminals I mentioned above, typing 
> '123456' on the keypad, followed by F1 l:
> 
> emacs -nw in xterm:   1 2 3 4 5 6 ESC O P l
> 
> emacs in rxvt-native:  1 2 3 4 5 6 ESC [ 1 1 ~ l
> 
> emacs in mintty:  1 2 3 4 5 6 ESC O P l

In Cygwin 1.5 xterm (TERM=xterm), with "emacs -q -nw" (or also with "-f
tpu-edt") I get

ESC [ > 1 ; 2 4 2 ; 0 c ESC O q ESC O r ESC O s ESC
O t ESC O u ESC O v ESC O P l

The initial "ESC [ > 1 ; 2 4 2 ; 0 c" is just the response from xterm, asked
for its version number (242). The "ESC O q" to "ESC O v" are the keypad
"123456", but somehow with numlock on (perhaps this is a feature of my
Exceed X-server). The "ESC O P l" is the "F1 l" at the end.

Despite the differences, it looks like neither of us is getting any
interpretation of the keys.

Thanks,
Tim.

> In the first and third cases, the environment variable TERM 
> is xterm before starting emacs, and COLORMTERM isn't set.  In 
> the second case, TERM=rxvt-cygwin-native and 
> COLORTERM=rxvt-xpm.  In all cases, including the good case 
> (emacs under X without -nw), TERM="dumb" within emacs, as 
> shown by evaluating (getenv "TERM").
> 
> Ken
> 
> --
> Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
> Problem reports:       http://cygwin.com/problems.html
> Documentation:         http://cygwin.com/docs.html
> FAQ:                   http://cygwin.com/faq/
> 
> 

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/